import VueLogger from './vue-logger'

const logger = new VueLogger('component')

const loggerMap = {
  log: logger.log,
  warn: logger.warn,
  error: logger.error,
  trace: logger.trace,
}

const componentLogger = {}

/**
 * 暴露install钩子，供vue注册
 * @param {Vue} Vue - Vue构造器类
 * @param {object} [options={}] - 开发组员的专属标识，调用方式为this.loga(msg)
 */
componentLogger.install = function (Vue, options = {}) { // 基础打印器
  Object.keys(loggerMap).forEach(key => {
    Vue.prototype[key] = function (...args) {
      loggerMap[key].call(logger, this, ...args)
    }
  })

  // const loggerToken = Object.assign({}, Vue.config.loggerToken, options)
  // // 含开发人员打印标识的打印器
  // Object.entries(loggerToken).forEach(([logKey, logValue]) => {
  //   Object.keys(loggerMap).forEach(key => {
  //     Vue.prototype[key + logKey] = function (...args) {
  //       Vue.prototype[key].call(this, `[${logValue}]`, ...args)
  //     }
  //   })
  // })
}

export default componentLogger
