
import Logger from './logger'

export default class VueLogger {
  constructor(namespace) {
    const logger = new Logger(namespace)

    const loggerList = ['log', 'warn', 'error', 'trace']

    loggerList.forEach(logType => {
      this[logType] = (vm, ...args) => {
        // if (!vm) {
        //   return
        // }
        logger[logType].call(logger, ...args)
      }
    })
  }

  /**
   * 更改全局配置参数
   * @param {object} [options={}] - 配置参数
   */
  static config(options = {}) {
    Logger.config(options)
  }
}
