const appConfig = require('../utils/get-app-config')
const testWebpack = require('../config/webpack.test.config')

// Karma configuration
// Generated on Sat May 19 2018 06:35:44 GMT+0800 (CST)

module.exports = function(config) {
  const isTDD = !!config.tdd

  const conf = {

    // base path that will be used to resolve all patterns (eg. files, exclude)
    // basePath: '',
    basePath: `${process.cwd()}/test`,

    // frameworks to use
    // available frameworks: https://npmjs.org/browse/keyword/karma-adapter
    frameworks: ['mocha'],
    // frameworks: ['mocha', 'sinon-chai'],

    reporters: ['spec', 'coverage'],

    // list of files / patterns to load in the browser
    files: [
      '**/*.spec.js'
    ],

    // list of files to exclude
    exclude: [
    ],

    webpack: testWebpack(isTDD),

    // preprocess matching files before serving them to the browser
    // available preprocessors: https://npmjs.org/browse/keyword/karma-preprocessor
    preprocessors: {
      '**/*.spec.js': ['webpack', 'sourcemap'],
    },

    // web server port
    port: 9876,

    // start these browsers
    // available browser launchers: https://npmjs.org/browse/keyword/karma-launcher
    browsers: ['Chrome'],

    singleRun: true,
  }

  if (isTDD) {
    conf.singleRun = false
  }

  if (!isTDD) {
    conf.coverageReporter = {
      dir: './coverage',
      reporters: [
        { type: 'lcov', subdir: '.' },
        { type: 'text-summary' }
      ]
    }
  }

  config.set(conf)
}
