const path = require('path')
const MiniCssExtractPlugin = require('mini-css-extract-plugin')
const { IS_PROD, IS_DEV } = require('./env.config')

exports.cssLoader = function ({ sourceMap = false }) {
  function generateLoaders(loader, loaderOpts) {
    const loaders = [
      { //默认loader
        loader: 'css-loader',
        options: {
          minimize: IS_PROD,
          sourceMap,
        },
      },
      { //默认loader
        loader: 'postcss-loader',
        options: {
          sourceMap,
        },
      },
    ]

    if (loader) {
      loaders.push({
        loader: `${loader}-loader`,
        options: Object.assign({}, loaderOpts, {
          sourceMap,
        })
      })
    }

    const lastLoader = IS_PROD ? [MiniCssExtractPlugin.loader] : ['vue-style-loader']

    return lastLoader.concat(loaders)
  }

  return {
    css: generateLoaders(),
    stylus: generateLoaders('stylus'),
    less: generateLoaders('less'),
  }
}
