const path = require('path')

// 项目地址
const projectPath = process.cwd()

// 项目配置地址
const appConfig = require(path.join(process.cwd(), 'app.config.js'))

// 项目编译地址
const publicPath = appConfig.deploy ? (appConfig.deploy.project || 'public') : 'public'

module.exports = {
  appConfig,

  projectPath,

  publicPath,

  resolve(dir, isRoot = true) {
    // 获取根目录地址
    let root = isRoot ? process.cwd() : __dirname

    if (dir instanceof Array) {
      return path.join(root, ...dir)
    }

    return path.join(root, dir)
  },

  readFile(fs, file) {
    return fs.readFileSync(path.join(publicPath, file), 'utf-8')
  },
}
